#include <compiler.h>
#include <vim.h>
#include <opdefs.h>
#include <asmstuff.h>

struct asminfo asmtable[113] = {
{0,A_DB},{0x37},{0xd5,A_AADAAM},{0xd4,A_AADAAM},
{0x3f},{0x10,A_MATH,0x80,2},{0x00,A_MATH,0x80,0},{0x20,A_MATH,0x80,4},
{0x62,A_LOADER,0x62},{0xe8,A_CALLJMP,0xff,2},{0x9a,A_FARCALL,0xff,3},{0x98},
{0xf8},{0xfc},{0xfa},{0xf5},
{0x38,A_MATH,0x80,7},{0xa6},{0xa7},{0x99},
{0x27},{0x2f},{0x48,A_INCDEC,0xfe,1},{0xf6,A_MULDIV,0xf6,6},
{0xc8,A_ENTER},{0,A_UNDEF},{0xf4},{0xf6,A_MULDIV,0xf6,7},
{0xf6,A_MULDIV,0xf6,5},{0xe4,A_INOUT},{0x40,A_INCDEC,0xfe,0},{0x6c},
{0x6d},{0xcd,A_INT},{0xce},{0xcf},
{0x77,A_JMPSHRT},{0x73,A_JMPSHRT},{0xe3,A_JMPSHRT},{0x7f,A_JMPSHRT},
{0x7d,A_JMPSHRT},{0xe9,A_CALLJMP,0xff,4},{0xea,A_FARCALL,0xff,5},{0x76,A_JMPSHRT},
{0x72,A_JMPSHRT},{0x7e,A_JMPSHRT},{0x7c,A_JMPSHRT},{0x71,A_JMPSHRT},
{0x79,A_JMPSHRT},{0x75,A_JMPSHRT},{0x70,A_JMPSHRT},{0x7a,A_JMPSHRT},
{0x7b,A_JMPSHRT},{0x78,A_JMPSHRT},{0x74,A_JMPSHRT},{0x9f},
{0xc5,A_LOADER,0xc5},{0x8d,A_LOADER,0x8d},{0xc9},{0xc4,A_LOADER,0xc4},
{0xf0},{0xac},{0xad},{0xe2,A_JMPSHRT},
{0xe0,A_JMPSHRT},{0xe1,A_JMPSHRT},{0xb0,A_MOV},{0xa4},
{0xa5},{0xf6,A_MULDIV,0xf6,4},{0xf6,A_MULDIV,0xf6,3},{0x90},
{0xf6,A_MULDIV,0xf6,2},{0x08,A_MATH,0x80,1},{0xe6,A_INOUT},{0x6e},
{0x6f},{0x58,A_PUSHPOP,0x8f},{0x61},{0x9d},
{0x50,A_PUSHPOP,0xff,6},{0x60},{0x9c},{0xd0,A_ROTSHF,0xd0,2},
{0xd0,A_ROTSHF,0xd0,3},{0xf3},{0xf2},{0xc3,A_RET},
{0xcb,A_RET},{0xd0,A_ROTSHF,0xd0,0},{0xd0,A_ROTSHF,0xd0,1},{0x9e},
{0xd0,A_ROTSHF,0xd0,7},{0x18,A_MATH,0x80,3},{0xae},{0xaf},
{0x2e},{0x3e},{0x26},{0x36},
{0xd0,A_ROTSHF,0xd0,4},{0xd0,A_ROTSHF,0xd0,5},{0xf9},{0xfd},
{0xfb},{0xaa},{0xab},{0x28,A_MATH,0x80,5},
{0x84,A_MATH,0xf6,0},{0x9b},{0x86,A_XCHG},{0xd7},
{0x30,A_MATH,0x80,6}
   };

struct sameas equivops[21] = {
{"JB",JNAE},{"JC",JNAE},{"JNB",JAE},{"JNC",JAE},
{"JE",JZ},{"JNE",JNZ},{"JBE",JNA},{"JNBE",JA},
{"JP",JPE},{"JNP",JPO},{"JL",JNGE},{"JNL",JGE},
{"JLE",JNG},{"JNLE",JG},{"REP",REPZ},{"REPE",REPZ},
{"REPNE",REPNZ},{"SAL",SHL},{"DW",DBYTE},{"LOOPE",LOOPZ},
{"LOOPNE",LOOPNZ}
   };
