/*
   This file is copyright (c) 1986, 1987 by William Couture.  All rights reserved.
*/


/*
   This file should be fairly self-explanatory.

   The order of the opnames is that of their definition in OPDEFS.H,
   and the index number of the instruction name is the #define number,
   and the array of pointers to functions defined in fns.c is also
   keyed to this order.  If you change ANY of them, YOU NEED TO CHANGE
   THEM ALL!
*/

char opnames[113][7] = {
"DB"    ,"AAA"   ,"AAD",   "AAM",
"AAS",   "ADC",   "ADD",   "AND",
"BOUND", "CALL",  "CALLF", "CBW",
"CLC",   "CLD",   "CLI",   "CMC",
"CMP",   "CMPSB", "CMPSW", "CWD",
"DAA",   "DAS",   "DEC",   "DIV",
"ENTER", "ESC",   "HLT",   "IDIV",
"IMUL",  "IN",    "INC",   "INSB",
"INSW",  "INT",   "INTO",  "IRET",
"JA",    "JAE",   "JCXZ",  "JG",
"JGE",   "JMP",   "JMPF",  "JNA",
"JNAE",  "JNG",   "JNGE",  "JNO",
"JNS",   "JNZ",   "JO",    "JPE",
"JPO",   "JS",    "JZ",    "LAHF",
"LDS",   "LEA",   "LEAVE", "LES",
"LOCK",  "LODSB", "LODSW", "LOOP",
"LOOPNZ","LOOPZ", "MOV",   "MOVSB",
"MOVSW", "MUL",   "NEG",   "NOP",
"NOT",   "OR",    "OUT",   "OUTSB",
"OUTSW", "POP",   "POPA",  "POPF",
"PUSH",  "PUSHA", "PUSHF", "RCL",
"RCR",   "REPZ",  "REPNZ", "RET",
"RETF",  "ROL",   "ROR",   "SAHF",
"SAR",   "SBB",   "SCASB", "SCASW",
"CS:",   "DS:",   "ES:",   "SS:",  /* these are here because of the names 
                                      SEG CS, etc. */
"SHL",   "SHR",   "STC",   "STD",
"STI",   "STOSB", "STOSW", "SUB",
"TEST",  "WAIT",  "XCHG",  "XLAT",
"XOR"
   };

/*  Note that register names are defined in opcode order */
char regnames[23][3] = {
"AX","CX","DX","BX","SP","BP","SI","DI","ES","CS","SS","DS","","AL","AX",
"AL","CL","DL","BL","AH","CH","DH","BH"
   };

char flagnames[2][9][3] = 
   {
      {"NV","UP","DI","NT","PL","NZ","NA","PO","NC"},
      {"OV","DN","EI","TR","NG","ZR","AC","PE","CY"}
   };
